PUSH [===[---@meta

]===]
DES 'arg'
PUSH [===[
---@type table
arg = {}

]===]
DES 'assert'
PUSH [===[
---@generic T
---@param v T
---@param message any
---@return T
function assert(v, message) end

---@alias cgopt
---|>'"collect"'      # ]===]
DESTAIL 'cgopt.collect'
PUSH [===[
---| '"stop"'         # ]===]
DESTAIL 'cgopt.stop'
PUSH [===[
---| '"restart"'      # ]===]
DESTAIL 'cgopt.restart'
PUSH [===[
---| '"count"'        # ]===]
DESTAIL 'cgopt.count'
PUSH [===[
---| '"step"'         # ]===]
DESTAIL 'cgopt.step'
PUSH [===[
---| '"isrunning"'    # ]===]
DESTAIL 'cgopt.isrunning'
PUSH [===[
]===]
if VERSION >= 5.4 then
PUSH [===[
---| '"incremental"'  # ]===]
DESTAIL 'cgopt.incremental'
PUSH [===[
---| '"generational"' # ]===]
DESTAIL 'cgopt.generational'
PUSH [===[
]===]
else
PUSH [===[
---| '"setpause"'     # ]===]
DESTAIL 'cgopt.setpause'
PUSH [===[
---| '"setstepmul"'   # ]===]
DESTAIL 'cgopt.setstepmul'
PUSH [===[
]===]
end
PUSH [===[

]===]
if VERSION >= 5.4 then
PUSH [===[
]===]
DES 'collectgarbage'
PUSH [===[
---@param opt? cgopt
---@return any
function collectgarbage(opt, ...) end
]===]
else
PUSH [===[
]===]
DES 'collectgarbage'
PUSH [===[
---@param opt? cgopt
---@param arg? integer
---@return any
function collectgarbage(opt, arg) end
]===]
end
PUSH [===[

]===]
DES 'dofile'
PUSH [===[
---@param filename? string
---@return any
function dofile(filename) end

]===]
DES 'error'
PUSH [===[
---@param message any
---@param level?  integer
function error(message, level) end

]===]
DES '_G'
PUSH [===[
---@class _G
_G = {}

---@version 5.1
]===]
DES 'getfenv'
PUSH [===[
---@param f? function
---@return table
function getfenv(f) end

]===]
DES 'getmetatable'
PUSH [===[
---@param object any
---@return table metatable
function getmetatable(object) end

]===]
DES 'ipairs'
PUSH [===[
---@param t table
---@return fun(t: table, i?: integer):integer, any iterator
---@return table t
---@return integer i
function ipairs(t) end

---@alias loadmode
---| '"b"'  # ]===]
DESTAIL 'loadmode.b'
PUSH [===[
---| '"t"'  # ]===]
DESTAIL 'loadmode.t'
PUSH [===[
---|>'"bt"' # ]===]
DESTAIL 'loadmode.bt'
PUSH [===[

]===]
if VERSION <= 5.1 then
PUSH [===[
]===]
DES 'load<5.1'
PUSH [===[
---@param func       function
---@param chunkname? string
---@return function
---@return string   error_message
function load(func, chunkname) end
]===]
else
PUSH [===[
]===]
DES 'load>5.2'
PUSH [===[
---@param chunk      string|function
---@param chunkname? string
---@param mode?      loadmode
---@param env?       table
---@return function
---@return string   error_message
function load(chunk, chunkname, mode, env) end
]===]
end
PUSH [===[

]===]
if VERSION <= 5.1 then
PUSH [===[
]===]
DES 'loadfile'
PUSH [===[
---@param filename? string
---@return function
---@return string   error_message
function loadfile(filename) end
]===]
else
PUSH [===[
]===]
DES 'loadfile'
PUSH [===[
---@param filename? string
---@param mode?     loadmode
---@param env?      table
---@return function
---@return string   error_message
function loadfile(filename, mode, env) end
]===]
end
PUSH [===[

---@version 5.1
]===]
DES 'loadstring'
PUSH [===[
---@param text       string
---@param chunkname? string
---@return function
---@return string error_message
function loadstring(text, chunkname) end

---@version 5.1
]===]
DES 'module'
PUSH [===[
---@param name string
function module(name, ...) end

]===]
DES 'next'
PUSH [===[
---@param table  table
---@param index? any
---@return any key
---@return any value
function next(table, index) end

]===]
DES 'paris'
PUSH [===[
---@param t table
---@return function next
---@return table
---@return nil
function pairs(t)
    return next
end

]===]
DES 'pcall'
PUSH [===[
---@param f     function
---@param arg1? any
---@return boolean success
---@return any result
---@return ...
function pcall(f, arg1, ...) end

]===]
DES 'print'
PUSH [===[
function print(...) end

]===]
DES 'rawequal'
PUSH [===[
---@param v1 any
---@param v2 any
---@return boolean
function rawequal(v1, v2) end

]===]
DES 'rawget'
PUSH [===[
---@param table table
---@param index any
---@return any
function rawget(table, index) end

]===]
DES 'rawlen'
PUSH [===[
---@param v table|string
---@return integer len
function rawlen(v) end

]===]
DES 'rawset'
PUSH [===[
---@param table table
---@param index any
---@param value any
---@return table
function rawset(table, index, value) end

]===]
DES 'select'
PUSH [===[
---@param index integer|'"#"'
---@return any
function select(index, ...) end

---@version 5.1
]===]
DES 'setfenv'
PUSH [===[
---@param f     function|integer
---@param table table
---@return function
function setfenv(f, table) end

]===]
DES 'setmetatable'
PUSH [===[
---@param table     table
---@param metatable table
---@return table
function setmetatable(table, metatable) end

]===]
DES 'tonumber'
PUSH [===[
---@param e     string|number
---@param base? integer
---@return number?
function tonumber(e, base) end

]===]
DES 'tostring'
PUSH [===[
---@param v any
---@return string
function tostring(v) end

---@alias type
---| '"nil"'
---| '"number"'
---| '"string"'
---| '"boolean"'
---| '"table"'
---| '"function"'
---| '"thread"'
---| '"userdata"'

]===]
DES 'type'
PUSH [===[
---@param v any
---@return type type
function type(v) end

]===]
DES '_VERSION'
PUSH [===[
]===]
if VERSION == 5.1 then
PUSH [===[
_VERSION = 'Lua 5.1'
]===]
elseif VERSION == 5.2 then
PUSH [===[
_VERSION = 'Lua 5.2'
]===]
elseif VERSION == 5.3 then
PUSH [===[
_VERSION = 'Lua 5.3'
]===]
elseif VERSION == 5.4 then
PUSH [===[
_VERSION = 'Lua 5.4'
]===]
end
PUSH [===[

---@version >5.4
]===]
DES 'warn'
PUSH [===[
---@param message string
function warn(message, ...) end

]===]
if VERSION == 5.1 and not JIT then
PUSH [===[
]===]
DES 'xpcall=5.1'
PUSH [===[
---@param f     function
---@param err   function
---@return boolean success
---@return any result
---@return ...
function xpcall(f, err) end
]===]
else
PUSH [===[
]===]
DES 'xpcall>5.2'
PUSH [===[
---@param f     function
---@param msgh  function
---@param arg1? any
---@return boolean success
---@return any result
---@return ...
function xpcall(f, msgh, arg1, ...) end
]===]
end
PUSH [===[

---@version 5.1
]===]
DES 'unpack'
PUSH [===[
---@param list table
---@param i?   integer
---@param j?   integer
function unpack(list, i, j) end
]===]